<template>
    <v-row dense>
        <v-col>
            <data-table
                v-model="items"
                :title="$tc('order', 2)"
                :endpoint="`/api/accounts/${id}/orders`"
                :headers="headers"
                :search-label="searchLabel"
                :force-fetch.sync="forceReload"
                :flat="true"
            >
                <template v-slot:buttons>
                    <v-btn
                        @click="openCreateOrderDialog"
                        color="primary"
                    >
                        <v-icon class="medium" color="white" left>mdi-plus</v-icon>
                        {{ $tc('order', 1) }}
                    </v-btn>
                </template>

                <template v-slot:item="{ item }">
                    <tr>
                        <td># {{ item.id }}</td>
                        <td>{{ item.amount | currency }} <span class="text-uppercase">{{ item.currency }}</span></td>
                        <td>
                            <v-chip
                                class="status mx-auto"
                                :class="`status--${item.status.name}`"
                                text-color="white"
                                label
                            >
                                {{ $t(item.status.name) }}
                            </v-chip>
                        </td>
                        <td>{{ item.order_at | date('Do MMM YYYY') }}</td>
                        <td>
                            <v-menu
                                :close-on-content-click="false"
                                offset-y
                                bottom
                            >
                                <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        color="primary"
                                        dark
                                        icon
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                        <v-icon>mdi-dots-horizontal</v-icon>
                                    </v-btn>
                                </template>
                                <v-list dense>
                                    <v-list-item>
                                        <v-btn
                                            :to="`/order/${item.id}`"
                                            class="text-capitalize"
                                            color="primary"
                                            text
                                            block
                                        >
                                            <v-icon left>mdi-eye</v-icon>
                                            {{ $t('view') }}
                                        </v-btn>
                                    </v-list-item>
                                    <v-list-item>
                                        <v-btn
                                            @click="openDeleteOrderDialog(item)"
                                            class="text-capitalize"
                                            color="error"
                                            text
                                            block
                                        >
                                            <v-icon>mdi-delete</v-icon>
                                            {{ $t('delete') }}
                                        </v-btn>
                                    </v-list-item>
                                </v-list>
                            </v-menu>
                        </td>
                    </tr>
                </template>
            </data-table>
        </v-col>
        <v-dialog
            v-model="deleteOrderDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="pt-2 mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="closeDeleteOrderDialog"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="deleteOrder"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
            v-if="createOrderDialog"
            v-model="createOrderDialog"
            @click:outside="onCloseCreateOrder"
            width="480"
        >
            <v-card>
                <v-card-text>
                    <order-creation
                        :id="id"
                        @created="onOrderCreated"
                    ></order-creation>
                </v-card-text>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import OrderCreation from "../order/OrderCreation";
    import { mapMutations } from "vuex";

    export default {
        name: 'UserOrder',
        components: { OrderCreation, DataTable },
        props: ['id'],
        data: () => ({
            loading: false,
            forceReload: false,
            items: [],
            createOrderDialog: false,
            deleteOrderDialog: false,
            deleting: null
        }),
        computed: {
            headers() {
                return [
                    { text: this.$t('id'), value: 'id', sortable: false },
                    { text: this.$t('amount'), value: 'amount' },
                    { text: this.$t('status'), value: 'status', align: 'center', sortable: false },
                    { text: this.$t('order_at'), value: 'order_at', sortable: false },
                    { text: this.$t('action'), value: 'action', sortable: false },
                ]
            },
            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('order_', [this.$t('id')])
                })
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            openCreateOrderDialog() {
                this.createOrderDialog = true;
            },
            onCloseCreateOrder() {
                this.createOrderDialog = false;
            },
            onOrderCreated() {
                this.onCloseCreateOrder();
                this.forceReload = true;
            },
            openDeleteOrderDialog(deleting) {
                this.deleting = deleting;
                this.deleteOrderDialog = true;
            },
            closeDeleteOrderDialog() {
                this.deleting = null;
                this.deleteOrderDialog = false;
            },
            deleteOrder() {
                this.loading = true;

                axios.delete(`api/orders/${this.deleting.id}`)
                    .then(({ data }) => {
                        if(data.result === true) {
                            const index = this.items.findIndex(item => item.id === this.deleting.id);
                            this.items.splice(index, 1);
                            this.success(this.$t('order_action.deleted'));
                            this.closeDeleteOrderDialog();
                        }
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            }
        }
    }
</script>

<style scoped>

</style>
